module Packman
  module Github
    module Configuration
      def config(github_options = {})
        @config ||= Config.new(github_options)
      end

      def configure
        yield config
      end

      class Config
        attr_accessor :token, :domain, :api_endpoint

        def initialize(options = {})
          @token = options[:token] || ENV['GITHUB_TOKEN']
          @domain = options[:domain] || ENV['GITHUB_DOMAIN'] || 'github.com'
          @api_endpoint = options[:api_endpoint] || ENV['GITHUB_API_ENDPOINT'] || 'https://api.github.com'
        end
      end
    end
  end
end
